<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_UserEnvironment
{
    public function action_index() {
        $teacher = Model_Teacher::with($this->user['TeacherID']);
        $disciplines = $teacher->getDisciplines();

        $subjID = $discID = $gradeNum = $i = $j = $k = 0; // Combo!!!
        $disciplinesHandled = array();
        $groupsInDiscipline = array();
        
        foreach ($disciplines as $dis) {
            if($subjID != $dis->subjectID || $gradeNum != $dis->gradeID) {
                $i++;
                $j = $k = 0;
                $subjID = $dis->subjectID;
                $gradeNum = $dis->gradeID;

                $groupsInDiscipline = array();
                $disciplinesHandled[$i] = [
                    'subjectName' => $dis->subjectName,
                    'gradeNum' => $dis->gradeNum,
                    'degree' => Model_Grades::getDegreeTitle($dis->degree),
                ];
            }
            
            if ($discID != $dis->ID) {
                $j++;
                $k = 0;

                $groupsInDiscipline = array();
                $row =& $disciplinesHandled[$i]['Disciplines'][$j];

                $row['isAuthor'] = $this->user['TeacherID'] == $dis->authorID;
                $row['isLocked'] = $dis->isLocked;
                $row['isMapCreated'] = $dis['isMapCreated'];
                $row['ID'] = $discID = $dis->ID;

                $row['control'] = DataHelper::LocalizeExamType($dis->type, $dis->subtype);
                $row['teachers'] = ($dis->subtype == 'scientific_coursework')
                    ? ['Сотрудники кафедры'] : self::getTeachersForDiscipline($dis->ID);
            }

            if ($dis['groupNum'])
                $groupsInDiscipline[++$k] = $dis['groupNum'] . ' гр.';

            $disciplinesHandled[$i]['Disciplines'][$j]['groups'] = implode(', ', $groupsInDiscipline);
        } //!for_each

        $twig = Twig::factory('teacher/index');
        $twig->Subjects = $disciplinesHandled;
        $twig->SemesterList = Model_Semesters::toArray();
        $twig->Semester = $this->SemesterInfo;
        $twig->User = $this->user;
        $this->response->body($twig);
    }
    
    public function action_settings() {
        $twig = Twig::factory('settings');
        $twig->User = $this->user;
        $this->response->body($twig);
    }
    
    protected function getTeachersForDiscipline($id) {
        $teachers = Model_Teachers::ofDiscipline($id);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++;
            $teachersHandled[$i] = $teacher['LastName'].' '.UTF8::substr($teacher['FirstName'], 0, 1).'. ';
            if(!empty($teacher['SecondName']))
            {
                $teachersHandled[$i] .= UTF8::substr($teacher['SecondName'], 0, 1).'.';
            }
        }
        return $teachersHandled;
    }
}